<?php

class FormController extends Zend_Controller_Action
{


    public function indexAction()
    {
        
    	$opts = array(
    		'elements' => array(
    			'firstname' => array(
    				'type' => 'Text',
    				'options' => array(
    					'label' => 'Имя'
    				)
    			),
    			'lastname' => array(
    				'type' => 'Text',
    				'options' => array(
    					'label' => 'Фамилия'
    				)
    			),
    			'items' => array(
    				'type' => 'MultiElement',
    				'options' => array(
    					'label' => 'Товары',
    					'required' => true,
    					'elements' => array(
    						'name' => array(
    							'type' => 'Text',
    							'options' => array(
    								'label' => 'Наименование',
    								'required' => true
    							)
    						),
    						'type' => array(
    							'type' => 'Select',
    							'options' => array(
    								'label' => 'Цвет',
    								'required' => true,
    								'multioptions' => array(
    									'green' => 'Зеленый',
    									'red' => 'Красный',
    									'blue' => 'Синий',
    								)
    							)
    						),
    						'price' => array(
    							'type' => 'Text',
    							'options' => array(
    								'label' => 'Стоимость, руб.',
    								'required' => true
    							)
    						),
    					)
    				)
    			),
    			'logons' => array(
    				'type' => 'MultiElement',
    				'options' => array(
    					'label' => 'Явки и пароли',
    					'required' => true,
    					'elements' => array(
    						'login' => array(
    							'type' => 'Text',
    							'options' => array(
    								'label' => 'Логин',
    								'required' => true
    							)
    						),
    						'passw' => array(
    							'type' => 'Text',
    							'options' => array(
    								'label' => 'Пароль',
    								'required' => true
    							)
    						),
    						'type' => array(
    							'type' => 'Select',
    							'options' => array(
    								'label' => 'Социальная сеть',
    								'required' => true,
    								'multioptions' => array(
    									'vk' => 'Вконтакте',
    									'fc' => 'FaceBook',
    									'tw' => 'Twitter',
    								)
    							)
    						),
    					)
    				)
    			),
    			'submit' => array(
    				'type' => 'Submit',
    				'options' => array(
    					'label' => 'Отправить'
    				)
    			),
    		),
    	);
    	
    	$form = new Zend_Form();
    	
    	$form->addPrefixPath('My_JQuery_Form','My/JQuery/Form');
    	$form->setOptions($opts);
    	
    	if($this->getRequest()->isPost()) {
    		
    		if($form->isValid($this->getRequest()->getPost())) {
    			
    			$values = $form->getValues();
    			$this->view->assign('MyFormValues',$values);
    			
    		}
    		
    	}
    	
    	$this->view->assign('MyForm',$form->render());
    	
    	
    }


}

