<?php

/**
 * @see Zend_Form_Element_Xhtml
 */
require_once "Zend/Form/Element/Xhtml.php";

class My_JQuery_Form_Element_MultiElement extends Zend_Form_Element_Xhtml {
	
	public $helper = "multiElement";
	
	/**
	 * Массив объектов формы для каждой группы дополнительных элементов
	 * @var array
	 */
	protected $forms = array();
	
	/**
	 * Объект формы дополнительных элементов
	 * @var Zend_Form
	 */
	protected $form;
	
	/**
	 * Отрендеренная форма дополнительных элементов
	 * @var string
	 */
	protected $renderform = '';
	
	/**
	 * Определяем массив опций и дергаем родительский конструктор
	 *
	 * @param mixed $spec
	 * @param array $options
	 */
	
	public function __construct($spec, $options = null) {

		/**
		 * Выделяем дополнительные элементы в отдельную форму и рендерим ее
		 */
		
		if(isset($options['elements']) && is_array($options['elements'])) {
			
			$form = new Zend_Form(array('elements'=>$options['elements']));
			
			$form -> removeDecorator('Form');
		    $form -> removeDecorator('DtDdWrapper');
			$form -> setElementsBelongTo($spec.'[]');
			
			$this->renderform = $form->render();
			unset($options['elements']);
			
			$this->form = $form;
		}
		
		/**
		 * Инициализируем родительский конструктор
		 */
		
		parent::__construct($spec, $options);
		
	}
	
	
	/**
	 * Валидация элемента
	 *
	 * @param mixed $value
	 * @return boolean
	 */
	
	public function isValid($value) {
		
		$this->setValue($value);
        $value = $this->getValue();
		
		if(!is_array($value) && $this->isRequired()) {
			$this->_messages = array('Значение обязательно для заполнения и не может быть пустым');
			return false;
		}
		
		$result = true;
		
		$this->_messages = array();
        $this->_errors   = array();
        
        if(is_array($value)) {
	        foreach ($value as $key=>$mini_form) {	
	        	if(key_exists($key,$this->forms)) {
	        		$form = $this->forms[$key];
	        		if(!$form->isValid($mini_form)) $result = false;
	        	}
			}
        }
		
		return $result;
		
	}
	
	/**
     * Set element value
     *
     * @param  array $value
     * @return Zend_Form_Element
     */
	
    public function setValue($value) {
    	
    	if(!is_array($value)) return $this;
    	
        $this->_value = $value;
        
        foreach ($value as $mini_form) {	
	        $form = clone $this->form;
	        $this->forms[] = $form->setDefaults($mini_form);
		}
        
        return $this;
        
    }
	
}