<?php

/**
 * @see ZendX_JQuery_View_Helper_UiWidget
 */
require_once "ZendX/JQuery/View/Helper/UiWidget.php";

class My_JQuery_View_Helper_MultiElement extends ZendX_JQuery_View_Helper_UiWidget {
	
	/**
	 * Рисуем элемент
	 *
	 * @param string $id Id HTML-элемента
	 * @param string $value Значение элемента
	 * @param array $params Массив конфигурации из секции options
	 * @return string
	 */
    
	public function multiElement($id, $value = null, array $params = array()) {
		
		/**
		 * Определяем форму с элементами группы
		 * Добавляем форму в JS
		 */
		
		$js_var = $id . '_subform';
		if(isset($params['renderform'])) {
			$this->jquery->addJavascript('var ' . $js_var . ' = ' . ZendX_JQuery::encodeJson($params['renderform']) . ';');
		}
		
		/**
	     * Определяем иконку удаления группы
	     */
	    
	    $icon_delete = $this->view->formButton($id . '_delete', 'Удалить');;
		
		/**
	     * Формируем кнопку добавления новой группы и вешаем на нее JS
	     */
	    
		$button_id = $id . '_add';
	    $button = $this->view->formButton($button_id, 'Добавить');
	    
	    $jquery_handler = ZendX_JQuery_View_Helper_JQuery::getJQueryHandler();
	    
	    $js = array();
	    
	    $js[] = sprintf('%s("#%s").next("ul").find("> li").prepend(%s("%s").click(function(){
		    	if(confirm("%s")) %s(this).parent("li").remove();
				return false;
		    }));',
		$jquery_handler, $button_id, $jquery_handler, addslashes($icon_delete), 'Удалить?', $jquery_handler);
	    
	    $js[] = sprintf('%s("#%s").click(function(){
		    	var itr = %s(this).next("ul").find("> li").length-1;
		    	var Tmpl = %s.replace(/name=\"%s\[\]\[/g,"name=\"%s["+itr+"][");
		    	var li = %s(this).next("ul").find("li:last").clone(true).insertBefore(%s(this).next("ul").find("li:last")).append(Tmpl).show();
	    	});',
        $jquery_handler, $button_id, $jquery_handler, $js_var, $id, $id, $jquery_handler, $jquery_handler);
        
        /**
         * Сортировка элементов группы
         */
        
        if(isset($params['sortable']) && $params['sortable']==true) {
        	$js[] = sprintf('%s("#%s").next("ul").sortable().find("li").css("cursor","move");',$jquery_handler,$button_id);
        }
	    
	    $this->jquery->addOnLoad(join(PHP_EOL,$js));
	    
	    /**
	     * Отрисовываем переданные группы и шаблон
	     */
	    
	    $xhtml = array();
	    $xhtml[] = '<ul>';
	    
	    $attribs = array();
	    foreach ($params as $k=>$v) if(in_array($k,array('class','style'))) $attribs[$k] = $v;
	    
	    /**
	     * Устанавливаем пришедшие значения
	     */
	    
		foreach ($params['forms'] as $key=>$form) {
	    	$form -> setElementsBelongTo($id . '['.$key.']');
	    	$xhtml[] = '<li' . $this->_htmlAttribs($attribs) . '>' . $form->render() . '</li>';
	    }
	    
	    /**
	     * Отрисовываем "хвост" списка
	     */
	    
		if(isset($attribs['style'])) $attribs['style'] .= ';display:none'; else $attribs['style'] = 'display:none'; 
	    $xhtml[] = '<li' . $this->_htmlAttribs($attribs) . '></li>';
	    $xhtml[] = '</ul>';
		
		return $button . join(PHP_EOL,$xhtml);
		
	}
	
}